Subject: Re: bug#8961: stdbuf has no effect on some programs

From: Pádraig Brady <[email-masked]>
Date: Thu, 30 Jun 2011 00:05:19 +0100

On 29/06/11 21:59, Bruno Haible wrote:
> Hi,
> 
> The glibc 'iconv' program buffers its input, and some people don't like this.
> I thought that the 'stdbuf' program could remove the buffering, but it does not
> work.

The following shows I think that iconv is bypassing stdio and buffering internally?

(echo; sleep 3; echo) | ltrace iconv -f ASCII

The stdbuf man page notes that:

NOTE: If COMMAND adjusts the buffering of its standard  streams  (`tee'
does  for  e.g.) then that will override corresponding settings changed
by `stdbuf'.  Also some filters (like `dd' and `cat'  etc.)  don't  use
streams for I/O, and are thus unaffected by `stdbuf' settings.

cheers,
Pádraig.